unit listau;

INTERFACE

uses telemu;

type
     PMut=^PElem;
     PElem=record
            ertek:TElemlista;
            mut:PMut;
            elozo:PMut;
           end;

     lista=class
            private
                fej,akt:PMut;
                hiba:boolean;
            public
                procedure ures;
                function urese:boolean;
                procedure kovetkezore;
                function telee:boolean;
                function hibase:boolean;
                procedure beszurmoge(e:TElemlista);
                procedure beszurele(e:TElemlista);
                procedure elsore;
                procedure elemertek(var e:TElemlista);
                procedure elemmodosit(e:TElemlista);
                procedure kihagy;
                function vegee:boolean;
                procedure talal(e:Telemlista; var van:boolean; var i:integer);{Egy konkret elemet keres}
                procedure csere(i,j:integer);
                procedure keres(e:integer; var i:PMut; var van:boolean);{Egy e. elemszamot keres}
                function elemszam:integer;
                procedure megfordit;
                procedure rendez;
                constructor Create;
                destructor Destroy;
            end;

IMPLEMENTATION

procedure lista.ures;
begin
  fej:=NIL;
  akt:=NIL;
  hiba:=false;
end;

function lista.urese:boolean;
begin
  urese:=(fej=NIL);
end;

procedure lista.kovetkezore;
begin
  if akt=NIL then hiba:=true
             else akt:=akt^.mut;
end;

function lista.telee:boolean;
begin
  telee:=false;
  //telee:=maxavail<sizeof(PElem);
  //nem mukodo fuggveny
end;

function lista.hibase:boolean;
begin
  hibase:=hiba;
end;

procedure lista.beszurmoge(e:TElemlista);
var uj:PMut;
begin
  if telee then hiba:=true
           else begin
                  new(uj);
                  uj^.ertek:=e;
                  uj^.mut:=NIL;
                  if urese then
                     begin
                     fej:=uj;
                     akt:=uj;
                     end
                     else begin
                          if akt=NIL then hiba:=true
                             else begin
                                  uj^.mut:=akt^.mut;
                                  akt^.mut:=uj;
                                  akt:=uj;
                                  end;
                          end;
                 end;
end;

procedure lista.beszurele(e:TElemlista);
var uj:PMut;
begin
  if telee then hiba:=true
           else begin
                  if fej=akt then
                     begin
                     new(fej);
                     fej^.ertek:=e;
                     fej^.mut:=akt;
                     akt:=fej;
                     end
                     else begin
                          if akt=NIL then hiba:=true
                          else begin
                               new(uj);
                               uj^.ertek:=akt^.ertek;
                               akt^.ertek:=e;
                               uj^.mut:=akt^.mut;
                               akt^.mut:=uj;
                               end;
                          end;
                end;
end;

procedure lista.elsore;
begin
  akt:=fej;
end;

procedure lista.elemertek(var e:TElemlista);
begin
  if akt=NIL then hiba:=true

             else begin
                    e:=akt^.ertek;
                  end;
end;

procedure lista.elemmodosit(e:TElemlista);
begin
  if akt=NIL then hiba:=true
             else begin
                    akt^.ertek:=e;
                  end;
end;

procedure lista.kihagy;
var elozo:PMut;
begin
  if akt=NIL then hiba:=true
             else begin
                    if fej=akt then
                       begin
                       fej:=fej^.mut;
                       dispose(akt);
                       akt:=fej;
                       end
                       else begin
                            elozo:=fej;
                            while elozo^.mut<>akt do
                                  begin
                                  elozo:=elozo^.mut;
                                  end;
                            elozo^.mut:=akt^.mut;
                            dispose(akt);
                            if elozo^.mut<>nil then akt:=elozo^.mut else
                               akt:=elozo;
                            end;
                  end;
end;

function lista.vegee:boolean;
begin
  if akt=NIL then hiba:=true
             else begin
                    vegee:=(akt^.mut=NIL);
                  end;
end;

function lista.elemszam:integer;
var i:integer;
         begin
         elsore;
         i:=1;
         while not(vegee) do
               begin
               i:=i+1;
               akt:=akt^.mut;
               end;
               elemszam:=i;
         end;

procedure lista.keres(e:integer; var i:PMut; var van:boolean);{Egy e. elemszamot keres}
var j:integer;
          begin
          elsore;
          j:=1;
             while (not(vegee)) and (e<>j) do
                   begin
                   akt:=akt^.mut;
                   j:=j+1;
                   end;
             van:=(e=j);
             if van then i:=akt;

          end;

procedure lista.talal(e:Telemlista; var van:boolean; var i:integer);{Egy konkret elemet keres}
          begin
        {  i:=1;
          while (not(vegee)) and (akt^.ertek<>e) do
                begin
                i:=i+1;
                akt:=akt^.mut;
                end;
          van:=(akt^.ertek<>e);}
          end;

procedure lista.csere(i,j:integer);
var e,f:PMut;
    seged:TElemlista;
    van,van2:boolean;
          begin
          keres(i,e,van);
          keres(j,f,van2);
          if (van and van2) then
             begin
             seged:=e^.ertek;
             e^.ertek:=f^.ertek;
             f^.ertek:=seged;
             end;
          end;

procedure lista.megfordit;
var i:integer;
          begin
          for i:=1 to elemszam div 2 do
              begin
              csere(i,elemszam-i+1);
              end;
          end;

procedure lista.rendez;{buborekos rendezessel}
{var i,j:integer;
    e,f:PMut;
    van,van2:boolean;}
          begin
      {      for i:=elemszam downto 2 do
                begin
                for j:=1 to i do
                    begin
                    keres(j,e,van);
                    keres(j+1,f,van2);
                    if e^.ertek>f^.ertek then csere(j,j+1);
                    end;
                end;    }
          end;

constructor lista.create;
        begin
        fej:=NIL;
        akt:=NIL;
        hiba:=false;
        end;

destructor lista.Destroy;
var sv:PMut;
        begin
        sv:=fej;
        akt:=fej;
        repeat
        akt:=akt.mut;
        dispose(sv);
        sv:=akt;
        until akt=nil;
        end;

begin
end.